# nextflow-workflow
Nextflow workflow for material classification

## Getting API key from PRISM

to get the API for the legacy API of PRISM go to https://next-gen.materialsproject.org/api

Visite your dashboard

Signin using your email

The site should send an email containing a login link

Click on the login link 

Click on the API option in the top bar of the page that opens

Get the API number from that page

## How to install nextflow

## How to update the docker file and container

Start by login into docker: ` docker login `

Next enter your credential for your docker account

Run the following command to build the image: ` docker build -t <Image name> --no-cache . `

Next tag the image using: ` docker tag <Image name> <UserName>/<Image name> `

Finally push the changed container to DockerHub: ` docker push <UserName>/<Image name> `

## How to connect a volume to a docker container

To connect a volume to the container when run locally run: ` docker run --mount type=bind,source="$(pwd)",target=/app -it --rm --name=cps_clean my-image bash `

NOTE: When using Fusion you either need to make sure that the container you use in not to large or you need to make sure you alocate enough memory to the process

## Fusion

To enable Fusion make sure to set the Fusion input in the nextflow.config file to true

To set the amount of memory for the process, set the memory variable in the process input of nextflow.config

- the memory value should include the size of the docker container plus extra for any data generated by the process (ex: if the docker is 1.69GB allocate around 3GB of memory for each process to ensure successful run)

To run Fusion you also need to enable wave and tower which are inputs as part of the nextflow.config file

## Tower

To run using tower, pass the -with-tower input after the run command of nextflow in bash.

To use tower, you need to setup a computing environment:

- Go to https://tower.nf/
- Login using an email
  - follow the email that you will receive from the website to complete the login
- Once you have successfully logged in, we now need to setup a computing environment 

## Seting up a computing environment with Fusion

## Examples to run:

If using slurm to run the nextflow controller:
run ` nohup bash run_nextflow.sh useSlurm 's3://nextflow-bucket-s3/data/' '<location where the base code is located on the local machine>/patch/data' 'results' `
If using the local machine to run the nextflow controller:
run ` nohup bash run_nextflow.sh NoSlurm 's3://nextflow-bucket-s3/data/' '<location where the base code is located on the local machine>/patch/data' 'results' `

## Setting up the drivers on AWS

G4.dn GPUs were used to setup this instance

The diver information are found at https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/install-nvidia-driver.html

The installation instruction are found: https://docs.nvidia.com/datacenter/tesla/tesla-installation-notes/index.html

ssh into the instance and run the following commands:

```
sudo yum install kernel-devel kernel-headers
sudo yum install make glibc-devel gcc patch
DRIVER\_VERSION=470.82.01
BASE\_URL=https://us.download.nvidia.com/tesla
curl -fSsl -O $BASE\_URL/$DRIVER\_VERSION/NVIDIA-Linux-x86\_64-$DRIVER\_VERSION.run
sudo sh NVIDIA-Linux-x86\_64-$DRIVER\_VERSION.run
```

if there are persistent issues with kernel source codes run the following: ` sudo yum install "kernel-devel-uname-r == $(uname -r)" `

## Torch on AWS

For G4.dn GPUs use the following torch version

` pip install torch==2.0.1 `
